/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   search.cpp                                         :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: adjoly <adjoly@student.42angouleme.fr>     +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2024/11/03 16:51:39 by adjoly            #+#    #+#             */
/*   Updated: 2024/11/03 16:57:33 by adjoly           ###   ########.fr       */
/*                                                                            */
/* ************************************************************************* */

#include "PhoneBook.hpp"
#include <iostream>
#include <ostream>
#include <string>

std::string	PhoneBook::__formatstr(std::string str) {
	if (str.size() > 10) {
		str.resize(9);
		str.append(".");
	}
	else {
		while (str.size() < 10)
			str.insert(0, " ");
	}
	return (str);
}

void	PhoneBook::__printContacts(void) {
	uint8_t	i;
	
	i = 0;
	std::cout << "|----------|----------|----------|----------|" << std::endl;
	while (i < 8)
	{
		std::cout << "|    " << (int)i + 1 << "     ";
		std::cout << "|" << __formatstr(this->_contact[i].getName());
		std::cout << "|" << __formatstr(this->_contact[i].getLastName());
		std::cout << "|" << __formatstr(this->_contact[i].getNickname());
		std::cout << "|" << std::endl;
		i++;
	}
	std::cout << "|----------|----------|----------|----------|" << std::endl;
}

void	PhoneBook::__printContact(uint8_t index) {
	std::cout << "Name : " << this->_contact[index].getName() << std::endl;
	std::cout << "Last name : " << this->_contact[index].getLastName() << std::endl;
	std::cout << "Nickname : " << this->_contact[index].getNickname() << std::endl;
	std::cout << "Phone number: " << this->_contact[index].getPhoneNbr() << std::endl;
	std::cout << "Darkest secret : " << this->_contact[index].getSecret() << std::endl;
}

void	PhoneBook::_search(void) {
	std::string	input;
	long long	index;

	__printContacts();
	std::cout << "Enter a contact index : ";
	if (!std::getline(std::cin, input))
		return ;
	index = input[0] - '1';
	if (index >= 0 && index <= 7) {
		if (this->_contact[index].getName().empty()) {
			std::cout << "Contact is empty" << std::endl;
			return ;
		}
		__printContact(index);
	}
	else
		std::cout << "Not a valid index" << std::endl;
	return ;
};
